/* errors.h 
 * Copyleft (C) 2009-2014 Antonio Maschio 
 * @ <ing dot antonio dot maschio at gmail dot com>
 * Update: 31 October 2017
 * 
 * This is tbas, a BASIC interpreter written for the UNIX world.
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This file contains the errors and warnings messages issued by tbas.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * It's GPL! Enjoy!
 */

char* error[]= {

/* SYSTEM ERRORS 
 * used by syserr_ and not be intercepted or by perror_ in preparsing phases */
/* 0 */	"? Enabled error condition",
/* 1 */	"? File %s not found",
/* 2 */	"? File %s contains no BASIC statements. Exiting",
/* 3 */	"? %s/ is a directory -- cannot execute. Exiting",
/* 4 */	"? Missing file name",
/* 5 */	"? Out of memory",
/* 6 */	"? Memory error",
/* 7 */	"? Too much variables/constants",
/* 8 */	" is an unrecognized option. Ignored.",
/* 9 */	"? Program too big (increase MEMLIMIT in tbas.h and recompile me)",
/*10 */	"? Line too long (break it in two or more lines)",
/*11 */	"? Invalid HANDLER name",
/*12 */	"? RESUME without ON ERROR/ON ATTENTION/NO DATA/WHEN ERROR",
/*13 */	"? RESUME without error condition",
/*14 */	"? END WHEN without WHEN ERROR",
/*15 */	"? EXIT HANDLER has no effect",
/*16 */	"? CONTINUE out of a WHEN ERROR structure", 
/*17 */	"? RETRY out of a WHEN ERROR structure",
/*18 */	"? USE without WHEN ERROR IN",
/*19 */	"? Incomplete WHEN ERROR structure",
/*20 */	"? Handler %s not found",
/*21 */	"? Cannot use JUMP out of ON ERROR/ON ATTENTION/NO DATA",
/*22 */	"? WHEN ERROR IN is not entirely contained",
/*23 */	"? WHEN ERROR USE/HANDLER cannot be used",
/*24 */	"? Illegal use of EXIT WHEN",

/* BASIC LANGUAGE ERRORS 
 * used by perror_ and interceptable unless in an ERROR routine */
/*25 */	"? End of file",
/*26 */	"? Unterminated IF/THEN",
/*27 */	"? Unterminated SELECT",
/*28 */	"? Unterminated DO/WHILE cycle",
/*29 */	"? Unterminated FOR cycle",
/*30 */	"? GOSUB within DEF or SUB",
/*31 */	"? Function defined twice",
/*32 */	"? Illegal argument for ASC function",
/*33 */	"? Illegal character %c",
/*34 */	"? Illegal matrix/array",
/*35 */	"? Illegal format",
/*36 */	"? Illegal format where the words THEN or GO TO were expected",
/*37 */	"? Illegal expression",
/*38 */	"? Illegal instruction",
/*39 */	"? Illegal line reference",
/*40 */	"? Unrecognized statement or variable name under OPTION EXPLICIT",
/*41 */	"? Illegal string relation",
/*42 */	"? Illegal variable",
/*43 */	"? Incorrect number of arguments",
/*44 */	"? Unrecognized statement or subroutine name",
/*45 */	"? Mixed strings and numbers",
/*46 */	"? Nested DEF",
/*47 */	"? NEXT without FOR",
/*48 */	"? %d is not an image",
/*49 */	"? No characters in image",
/*50 */	"? No data",
/*51 */	"? Illegal matrix in dot product",
/*52 */	"? No FNEND for DEF FN%c",
/*53 */	"? Out of room",
/*54 */	"? RETURN within DEF",
/*55 */	"? Specified line is not an image",
/*56 */	"? String record length > 255 or < 1",
/*57 */	"? Illegal label",
/*58 */	"? Attempt to put# or get# past EOF in file %s", 
/*59 */	"? Too many files",
/*60 */	"? Undefined FN%c function",
/*61 */	"? Undefined label",
/*62 */	"? Illegal one-dimensional array",
/*63 */	"? Variable dimensioned twice",
/*64 */	"? Vector cannot be array",
/*65 */	"? %s was seen where %s was expected",
/*66 */	"? Absolute value raised to power",
/*67 */	"? Attempt to output a negative number to a *, 0 or $ field",
/*68 */	"? Attempt to output a number to a string field or vice versa",
/*69 */	"? Attempt to read# or input# from a file which does not exist",
/*70 */	"? Attempt to read# / input# from a file in write# / print# mode",
/*71 */	"? Attempt to set/write a line label > 99999",
/*72 */	"? Attempt to get# from a file in write mode",
/*73 */	"? Attempt to write# / print# from a file in read# / input# mode",
/*74 */	"? Attempt to put# from a file in input mode",
/*75 */	"? DATA file line too long",
/*76 */	"? DIMENSION error",
/*77 */	"%% Division by zero",
/*78 */	"? Exponent requested for *, 0 or $ field",
/*79 */	"%% Unrecognized OPTION feature",
/*80 */	"? File never established -- referenced",
/*81 */	"? File not found by RESTORE command",
/*82 */	"? File %s on more than one channel",
/*83 */	"? Attempt to reopen channel %d already established",
/*84 */	"? File record length or type does not match",
/*85 */	"? Attempt to read EOF from a file not in read# / input# mode",
/*86 */	"? Illegal character in string",
/*87 */	"? Illegal character seen",
/*88 */	"? Illegal filename",
/*89 */	"? Illegal line reference in chain",
/*90 */	"? Impossible vector length",
/*91 */	"%% INPUT data not in correct form -- please retype",
/*92 */	"? Attempt to use LREAD/LINPUT with random access",
/*93 */	"? Illegal string",
/*94 */	"? Line number out of bounds",
/*95 */	"? LOG/LOG10 argument is negative",
/*96 */	"%% LOG/LOG10 of zero",
/*97 */	"? Bad data into line %d\n",
/*98 */	"? Margin out of bounds",
/*99 */	"? Margin too small",
/*100*/	"? Not a sequential access file",
/*101*/	"? Mixed random & sequential access",
/*102*/	"? Mixed READ#/INPUT#",
/*103*/	"? Mixed WRITE#/PRINT#",
/*104*/	"? Wrongly referenced file",
/*105*/	"? No fields in image",
/*106*/	"? No room for string",
/*107*/	"? Starting line not found in run or chain",
/*108*/	"? DIMENSION error -- attempt to go past the default BASE",
/*109*/	"? ON evaluated out of range",
/*110*/	"? Out of DATA",
/*111*/	"? Output item too long for line",
/*112*/	"? Output line > 255 characters",
/*113*/	"? Output string length > record length",
/*114*/	"? RESTORE couldn't find %s DATA line %d",
/*115*/	"? VAL argument does not contain a ground number",
/*116*/	"? PAGE length out of bounds",
/*117*/	"? Vectors in dot product differ in length",
/*118*/	"? RETURN before GOSUB",
/*119*/	"? Incorrect argument list in SUB/DEF structure",
/*120*/	"? SET argument out of bounds",
/*121*/	"%% Singular matrix inverted",
/*122*/	"? Matrix is not square",
/*123*/	"? SQRT of a negative number",
/*124*/	"? String formula > 255 characters",
/*125*/	"? Statement requires an argument",
/*126*/	"? Subroutine or function calls itself",
/*127*/	"%% TAN of +/-pi/2 or COT of 0.0",
/*128*/	"? Irregular matrix in DET function", 
/*129*/	"? Array values not available as SUB arguments",
/*130*/	"%% VAL/EXPR argument was not exhausted",
/*131*/	"? VAL/EXPR argument is empty",
/*132*/	"? Zero to a negative power",
/*133*/	"? Channel number is <1 or >9",
/*134*/	"? ASIN argument is lesser than -1.0 or greater than 1.0",
/*135*/	"? ACOS argument is lesser than -1.0 or greater than 1.0",
/*136*/	"? ASEC argument is in the interval -1.0/1.0",
/*137*/	"? ACOSEC argument is in the interval -1.0/1.0",
/*138*/ "? ACOSH argument is lesser than 1.0",
/*139*/ "? ATANH argument is out of the interval -1.0/1.0",
/*140*/	"? ACOTH argument is in the interval -1.0/1.0",
/*141*/ "? ASECH argument is lesser than 0.0 or greater than 1.0",
/*142*/ "? Irregular queue file for PREPEND",
/*143*/	"%% BIN/OCT/HEX argument was not exhausted",
/*144*/	"? Data is not in correct form",
/*145*/	"",
/*146*/	"",
/*147*/ "%% NXL() argument is NULL, returning 0",
/*148*/	"? Illegal dimension index",
/*149*/	"%% CLOSE called on unopened channel %d",
/*150*/ "? Illegal specifier for OPEN",
/*151*/ "? File %s not found",
/*152*/ "Missing r&w permissions, cannot open file %s",
/*153*/ "? Printer-file for QUEUE or LPRINT couldn't be created",
/*154*/ "? Illegal ROUTE statement",
/*155*/ "Cannot set write-mode on the read-only file %s",
/*156*/ "Cannot open as read-only the write-mode file %s",
/*157*/ "Cannot open read-only file %s for writing",
/*158*/ "Cannot open write-only file %s for reading",
/*159*/ "%% Null string as filename",
/*160*/ "%% Illegal decimal year -- returning %d",
/*161*/ "? Illegal COMMAND argument",
/*162*/ "",
/*163*/ "",
/*164*/ "? No USE section found in WHEN ERROR IN structures",
/*165*/ "? Unterminated handler",
/*166*/ "? Unterminated WHEN ERROR structure",
/*167*/ "",
/*168*/ "System stack overflow",
/*169*/ "",
/*170*/ "? Invalid variable name",
/*171*/ "? Invalid INTEGER specifier",
/*172*/ "? Invalid SUB name",
/*173*/	"? Out of memory with variables",
/*174*/	"? Out of memory with HANDLER data",
/*175*/	"? Out of memory while setting SELECT argument",
/*176*/	"? Array/matrix size exceeds current memory space",
/*177*/	"",	
/*178*/	"",
/*179*/ "",		
/*180*/ "%% PREPEND is already active on channel %d",
/*181*/ "",		
/*182*/ "",		
/*183*/ "",
/*184*/ "",
/*185*/ "",
/*186*/ "",
/*187*/ "? Recursion limit violated",
/*188*/ "? Cannot jump out of FN%c - illegal line reference %d",
/*189*/ "? Cannot jump out of SUB %s - illegal line reference %d",
/*190*/ "? Out of memory while dimensioning an array",
/*191*/ "? Missing assignment to constant declaration",
/*192*/ "? Out of memory while defining DEF FN%c function",
/*193*/ "? Out of memory while storing DATA strings",
/*194*/ "? Out of memory while storing line %d",
/*195*/ "? Out of memory while executing SUB %s",
/*196*/ "? Nested GOSUB limit violated",
/*197*/ "? Illegal EXIT/CONTINUE DO",
/*198*/ "? Illegal EXIT/CONTINUE WHILE",
/*199*/ "? Illegal EXIT/CONTINUE FOR",
/*200*/ "",
/*201*/ "? Illegal EXPORT statement",
/*202*/ "? Illegal EXIT statement",
/*203*/ "? EXIT used outside of any cycle",
/*204*/ "? BREAK used outside of any cycle",
/*205*/ "? Illegal assignment to constant %s",
/*206*/ "? ELSE out of an IF-THEN-ENDIF clause",
/*207*/ "? ENDIF out of an IF-THEN-ENDIF clause",
/*208*/ "? END FUNCTION is not accepted - use END SUB instead",
/*209*/ "? END WHILE out of a WHILE-END WHILE clause",
/*210*/ "? No END SUB for sub %s",
/*211*/ "? Cannot execute a function as a procedure",
/*212*/ "? Subroutine not found",
/*213*/ "? Out of memory while executing DEF FN%c",
/*214*/ "? Numeric argument found where string argument was expected",
/*215*/ "? String argument found where numeric argument was expected",
/*216*/ "? Error in evaluating SUB return value",
/*217*/ "? Wrong numeric argument",
/*218*/ "? Wrong string argument",
/*219*/ "? LOOP without DO WHILE or DO UNTIL",
/*220*/ "%% SUB RETURN value not calculated",
/*221*/ "? EXIT SUB out of a subroutine",
/*222*/ "? END SELECT out of a SELECT-END SELECT clause",
/*223*/ "? Exhausted variables memory space",
/*224*/ "? CASE out of a SELECT-END SELECT clause",
/*225*/ "",

/*L+1*/ ""					/* last + 1 */
};

#define ERRLIM 226				/* L + 1 */

